package lichen.utils

// Copyright 2012 The EGF IT Software Department.
// site: http://www.egfit.com

import collection.JavaConversions._
import java.lang.String
import org.apache.tapestry5.ioc.internal.services._

/**
 * 解析表达式.
 * 譬如将表达式中 "my name:${name}",根据提供的变量进行解析
 * @see SymbolSource
 * @see MapSymbolProvider
 * @author jcai
 */
object SymbolExpander {
    /**
     * 解析表达式
     * @param input 输入的字符串
     * @param params 传入的变量
     * @return 解析后的字符串
     */
    def expand(input: String, params: Option[Map[String, String]]=None):String= {
        var list = List(new SystemPropertiesSymbolProvider,new SystemEnvSymbolProvider)
        if(params.isDefined){
            list = list :+ (new MapSymbolProvider(params.get))
        }
        val symbolSource = new SymbolSourceImpl(list);
        return symbolSource.expandSymbols(input)
    }
}